/* A Bison parser, made by GNU Bison 1.875a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse mathparse
#define yylex   mathlex
#define yyerror matherror
#define yylval  mathlval
#define yychar  mathchar
#define yydebug mathdebug
#define yynerrs mathnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     EOS = 258,
     EOL = 259,
     KW_IF = 260,
     KW_ELSE = 261,
     KW_FOR = 262,
     KW_DO = 263,
     KW_WHILE = 264,
     KW_BREAK = 265,
     KW_CONTINUE = 266,
     SY_ASSGIN_MUL = 267,
     SY_ASSGIN_DIV = 268,
     SY_ASSGIN_MIN = 269,
     SY_ASSGIN_PLUS = 270,
     SY_ASSGIN = 271,
     NUM = 272,
     FUNC = 273,
     VAR = 274,
     SY_NEQ = 275,
     SY_EQ = 276,
     SY_LE = 277,
     SY_GE = 278,
     SY_LS = 279,
     SY_GR = 280,
     SY_ANDAND = 281,
     SY_OROR = 282,
     SY_XOR = 283,
     SY_AND = 284,
     SY_OR = 285,
     SY_MOD = 286,
     SY_LNOT = 287,
     SY_NOT = 288,
     NEG = 289
   };
#endif
#define EOS 258
#define EOL 259
#define KW_IF 260
#define KW_ELSE 261
#define KW_FOR 262
#define KW_DO 263
#define KW_WHILE 264
#define KW_BREAK 265
#define KW_CONTINUE 266
#define SY_ASSGIN_MUL 267
#define SY_ASSGIN_DIV 268
#define SY_ASSGIN_MIN 269
#define SY_ASSGIN_PLUS 270
#define SY_ASSGIN 271
#define NUM 272
#define FUNC 273
#define VAR 274
#define SY_NEQ 275
#define SY_EQ 276
#define SY_LE 277
#define SY_GE 278
#define SY_LS 279
#define SY_GR 280
#define SY_ANDAND 281
#define SY_OROR 282
#define SY_XOR 283
#define SY_AND 284
#define SY_OR 285
#define SY_MOD 286
#define SY_LNOT 287
#define SY_NOT 288
#define NEG 289




/* Copy the first part of user declarations.  */
#line 19 "mathparse.y"

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "mathcompile.h"
#include "common.h"

#if 0
#	define YYDEBUG 1
#	define YYERROR_VERBOSE 1
#endif

#define ERR scivi_complier_error

#define YYPARSE_PARAM p

int mathlex();
void matherror(const char *s){dprintf("bison: parse error: %s\n",s);}


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 43 "mathparse.y"
typedef union YYSTYPE {
struct {
	int line;
	/* union'ify these */
	void *exp;
	float num;
	char *str; /* buffer is malloc'd by code in lex-file */
} d;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 187 "mathparse.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 199 "mathparse.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  45
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   425

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  46
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  28
/* YYNRULES -- Number of rules. */
#define YYNRULES  80
/* YYNRULES -- Number of states. */
#define YYNSTATES  152

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   289

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      41,    42,    34,    31,    43,    32,     2,    33,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    44,     2,    45,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    39,     2,    40,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    35,    36,    37,    38
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,    10,    12,    15,    18,    20,    22,
      25,    27,    30,    33,    36,    39,    41,    44,    48,    52,
      53,    61,    62,    63,    67,    68,    75,    76,    84,    85,
      96,    98,    99,   101,   103,   105,   107,   109,   113,   117,
     121,   125,   129,   133,   137,   141,   145,   149,   153,   156,
     159,   163,   167,   171,   175,   179,   183,   187,   191,   195,
     199,   203,   207,   211,   214,   218,   222,   226,   230,   231,
     237,   238,   240,   242,   246,   248,   249,   253,   255,   258,
     262
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      47,     0,    -1,    -1,    49,     3,    48,     1,     3,    -1,
      50,    -1,    49,    50,    -1,    64,     4,    -1,    52,    -1,
      56,    -1,    58,     4,    -1,    60,    -1,    10,     4,    -1,
      11,     4,    -1,     1,     4,    -1,     1,     3,    -1,    50,
      -1,    39,    40,    -1,    39,    49,    40,    -1,    39,     1,
      40,    -1,    -1,     5,    41,    64,    42,    53,    51,    54,
      -1,    -1,    -1,     6,    55,    51,    -1,    -1,     9,    41,
      64,    42,    57,    51,    -1,    -1,     8,    59,    51,     9,
      41,    64,    42,    -1,    -1,     7,    41,    63,    62,    63,
      62,    63,    42,    61,    51,    -1,     4,    -1,    -1,    64,
      -1,    17,    -1,    19,    -1,    70,    -1,    65,    -1,    19,
      16,    64,    -1,    19,    15,    64,    -1,    19,    14,    64,
      -1,    19,    13,    64,    -1,    19,    12,    64,    -1,    70,
      16,    64,    -1,    70,    15,    64,    -1,    70,    14,    64,
      -1,    70,    13,    64,    -1,    70,    12,    64,    -1,    64,
      30,    64,    -1,    37,    64,    -1,    36,    64,    -1,    64,
      29,    64,    -1,    64,    28,    64,    -1,    64,    35,    64,
      -1,    64,    27,    64,    -1,    64,    26,    64,    -1,    64,
      25,    64,    -1,    64,    24,    64,    -1,    64,    23,    64,
      -1,    64,    22,    64,    -1,    64,    21,    64,    -1,    64,
      20,    64,    -1,    64,    31,    64,    -1,    64,    32,    64,
      -1,    32,    64,    -1,    64,    33,    64,    -1,    64,    34,
      64,    -1,    41,    64,    42,    -1,    41,     1,    42,    -1,
      -1,    18,    41,    66,    67,    42,    -1,    -1,    68,    -1,
      69,    -1,    68,    43,    69,    -1,    64,    -1,    -1,    19,
      71,    72,    -1,    73,    -1,    72,    73,    -1,    44,    64,
      45,    -1,    44,     1,    45,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,    98,    98,    98,   104,   105,   109,   110,   111,   112,
     113,   114,   115,   116,   121,   129,   130,   131,   132,   137,
     137,   141,   143,   143,   148,   148,   154,   154,   163,   160,
     168,   173,   174,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   188,   189,   190,   191,   192,   194,   195,   196,
     197,   198,   199,   201,   202,   204,   205,   206,   207,   208,
     209,   211,   212,   213,   214,   215,   216,   217,   223,   223,
     227,   229,   233,   234,   238,   243,   243,   248,   249,   253,
     254
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "EOS", "EOL", "KW_IF", "KW_ELSE", "KW_FOR", 
  "KW_DO", "KW_WHILE", "KW_BREAK", "KW_CONTINUE", "SY_ASSGIN_MUL", 
  "SY_ASSGIN_DIV", "SY_ASSGIN_MIN", "SY_ASSGIN_PLUS", "SY_ASSGIN", "NUM", 
  "FUNC", "VAR", "SY_NEQ", "SY_EQ", "SY_LE", "SY_GE", "SY_LS", "SY_GR", 
  "SY_ANDAND", "SY_OROR", "SY_XOR", "SY_AND", "SY_OR", "'+'", "'-'", 
  "'/'", "'*'", "SY_MOD", "SY_LNOT", "SY_NOT", "NEG", "'{'", "'}'", "'('", 
  "')'", "','", "'['", "']'", "$accept", "begin", "@1", "stmts", "stmt", 
  "braced", "stmtif", "@2", "stmtifelse", "@3", "stmtwhile", "@4", 
  "stmtdo", "@5", "stmtfor", "@6", "semicolon", "optexpr", "expr", 
  "funct", "@7", "functoptprms", "functprms", "functprm", "vararray", 
  "@8", "varaind", "varainde", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    43,    45,    47,    42,   286,   287,   288,   289,   123,
     125,    40,    41,    44,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    46,    48,    47,    49,    49,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    51,    51,    51,    51,    53,
      52,    54,    55,    54,    57,    56,    59,    58,    61,    60,
      62,    63,    63,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    66,    65,
      67,    67,    68,    68,    69,    71,    70,    72,    72,    73,
      73
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     5,     1,     2,     2,     1,     1,     2,
       1,     2,     2,     2,     2,     1,     2,     3,     3,     0,
       7,     0,     0,     3,     0,     6,     0,     7,     0,    10,
       1,     0,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     3,     3,     3,     0,     5,
       0,     1,     1,     3,     1,     0,     3,     1,     2,     3,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,    26,     0,     0,     0,    33,     0,
      34,     0,     0,     0,     0,     0,     0,     4,     7,     8,
       0,    10,     0,    36,    35,    14,    13,     0,    31,     0,
       0,    11,    12,    68,     0,     0,     0,     0,     0,     0,
      63,    49,    48,     0,     0,     1,     2,     5,     9,     6,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    32,     0,    15,     0,     0,    70,    41,
      40,    39,    38,    37,     0,    76,    77,    67,    66,     0,
      60,    59,    58,    57,    56,    55,    54,    53,    51,    50,
      47,    61,    62,    64,    65,    52,    46,    45,    44,    43,
      42,    19,    30,    31,     0,    16,     0,     0,    24,    74,
       0,    71,    72,     0,     0,    78,     0,     0,     0,    18,
      17,     0,     0,    69,     0,    80,    79,     3,    21,    31,
       0,    25,    73,    22,    20,     0,    27,     0,    28,    23,
       0,    29
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    15,    89,    16,    75,    76,    18,   127,   144,   147,
      19,   132,    20,    29,    21,   150,   113,    72,    22,    23,
      78,   120,   121,   122,    24,    39,    85,    86
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -115
static const short yypact[] =
{
     219,    11,   -37,   -29,  -115,   -21,    18,    24,  -115,   -10,
      -6,   276,   276,   276,    64,    32,    67,  -115,  -115,  -115,
      30,  -115,   241,  -115,    48,  -115,  -115,   276,   276,   108,
     276,  -115,  -115,  -115,   276,   276,   276,   276,   276,    -9,
    -115,  -115,  -115,    27,   298,  -115,  -115,  -115,  -115,  -115,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   276,
     276,   321,    76,   390,   145,  -115,    62,   344,   276,   390,
     390,   390,   390,   390,   216,    -9,  -115,  -115,  -115,    94,
     103,   103,   103,   103,   103,   103,    56,    56,    56,    56,
      56,    59,    59,  -115,  -115,  -115,   390,   390,   390,   390,
     390,  -115,  -115,   276,    26,  -115,   182,    57,  -115,   390,
      55,    63,  -115,    65,   257,  -115,   104,   108,    76,  -115,
    -115,   276,   108,  -115,   276,  -115,  -115,  -115,   105,   276,
     367,  -115,  -115,  -115,  -115,    70,  -115,   108,  -115,  -115,
     108,  -115
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
    -115,  -115,  -115,    40,     5,  -114,  -115,  -115,  -115,  -115,
    -115,  -115,  -115,  -115,  -115,  -115,    -4,  -102,   -11,  -115,
    -115,  -115,  -115,   -12,  -115,  -115,  -115,    54
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -76
static const short yytable[] =
{
      40,    41,    42,    44,    27,    17,    34,    35,    36,    37,
      38,   128,    28,   138,    25,    26,    71,    73,   141,    77,
      30,    47,    31,    79,    80,    81,    82,    83,    32,    25,
      26,    33,    45,   149,    48,    84,   151,   145,   -75,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      66,    67,    68,    69,    70,    43,   129,   119,     1,    87,
      46,   117,     2,   124,     3,     4,     5,     6,     7,    17,
     112,     8,     9,    10,     8,     9,    10,    61,    62,    63,
      64,    65,    63,    64,    65,   126,    11,   133,   131,    11,
      12,    13,    73,    12,    13,    14,   134,   137,    14,     1,
     135,   143,   148,     2,   116,     3,     4,     5,     6,     7,
     140,    47,   142,   119,   139,     8,     9,    10,    73,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,   125,
      11,     0,     0,     0,    12,    13,   114,    74,     0,    14,
       2,     0,     3,     4,     5,     6,     7,     0,     0,     0,
       0,     0,     8,     9,    10,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    11,     0,     0,
       0,    12,    13,     1,     0,   115,    14,     2,     0,     3,
       4,     5,     6,     7,     0,     0,     0,     0,     0,     8,
       9,    10,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    11,     0,     0,   123,    12,    13,
       1,     0,   130,    14,     2,     0,     3,     4,     5,     6,
       7,     0,     0,     8,     9,    10,     8,     9,    10,     0,
       0,     0,     0,     0,     0,    49,     0,     0,    11,     0,
       0,    11,    12,    13,     0,    12,    13,    14,     0,     0,
      14,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,     8,     9,    10,     0,     0,     0,     0,
       0,     0,   136,     0,     0,     0,     0,     0,    11,     0,
       0,     0,    12,    13,     0,     0,     0,    14,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,     0,     0,     0,     0,     0,     0,
      88,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,     0,     0,     0,
       0,     0,     0,   111,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
       0,     0,     0,     0,     0,     0,   118,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,     0,     0,     0,     0,     0,     0,   146,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65
};

static const short yycheck[] =
{
      11,    12,    13,    14,    41,     0,    12,    13,    14,    15,
      16,   113,    41,   127,     3,     4,    27,    28,   132,    30,
      41,    16,     4,    34,    35,    36,    37,    38,     4,     3,
       4,    41,     0,   147,     4,    44,   150,   139,    44,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      12,    13,    14,    15,    16,     1,    40,    78,     1,    42,
       3,     9,     5,    84,     7,     8,     9,    10,    11,    74,
       4,    17,    18,    19,    17,    18,    19,    31,    32,    33,
      34,    35,    33,    34,    35,     1,    32,    42,    41,    32,
      36,    37,   113,    36,    37,    41,    43,     3,    41,     1,
      45,     6,    42,     5,    74,     7,     8,     9,    10,    11,
     131,   116,   134,   134,   128,    17,    18,    19,   139,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    85,
      32,    -1,    -1,    -1,    36,    37,     1,    39,    -1,    41,
       5,    -1,     7,     8,     9,    10,    11,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,
      -1,    36,    37,     1,    -1,    40,    41,     5,    -1,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,     1,    36,    37,
       1,    -1,    40,    41,     5,    -1,     7,     8,     9,    10,
      11,    -1,    -1,    17,    18,    19,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,     4,    -1,    -1,    32,    -1,
      -1,    32,    36,    37,    -1,    36,    37,    41,    -1,    -1,
      41,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    36,    37,    -1,    -1,    -1,    41,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     5,     7,     8,     9,    10,    11,    17,    18,
      19,    32,    36,    37,    41,    47,    49,    50,    52,    56,
      58,    60,    64,    65,    70,     3,     4,    41,    41,    59,
      41,     4,     4,    41,    12,    13,    14,    15,    16,    71,
      64,    64,    64,     1,    64,     0,     3,    50,     4,     4,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    12,    13,    14,    15,
      16,    64,    63,    64,    39,    50,    51,    64,    66,    64,
      64,    64,    64,    64,    44,    72,    73,    42,    42,    48,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    42,     4,    62,     1,    40,    49,     9,    42,    64,
      67,    68,    69,     1,    64,    73,     1,    53,    63,    40,
      40,    41,    57,    42,    43,    45,    45,     3,    51,    62,
      64,    51,    69,     6,    54,    63,    42,    55,    42,    51,
      61,    51
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {
      case 18: /* FUNC */
#line 81 "mathparse.y"
        {
	if ((yyvaluep->d.str) != NULL)
		free(yyvaluep->d.str); 
};
#line 969 "mathparse.tab.c"
        break;
      case 19: /* VAR */
#line 81 "mathparse.y"
        {
	if ((yyvaluep->d.str) != NULL)
		free(yyvaluep->d.str); 
};
#line 977 "mathparse.tab.c"
        break;
      case 50: /* stmt */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 985 "mathparse.tab.c"
        break;
      case 52: /* stmtif */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 993 "mathparse.tab.c"
        break;
      case 56: /* stmtwhile */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 1001 "mathparse.tab.c"
        break;
      case 58: /* stmtdo */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 1009 "mathparse.tab.c"
        break;
      case 60: /* stmtfor */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 1017 "mathparse.tab.c"
        break;
      case 63: /* optexpr */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 1025 "mathparse.tab.c"
        break;
      case 64: /* expr */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 1033 "mathparse.tab.c"
        break;
      case 65: /* funct */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 1041 "mathparse.tab.c"
        break;
      case 70: /* vararray */
#line 87 "mathparse.y"
        {
	if ((yyvaluep->d.exp) != NULL)
		MATH(expr_free)(yyvaluep->d.exp); 
};
#line 1049 "mathparse.tab.c"
        break;

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 98 "mathparse.y"
    { YYACCEPT; ;}
    break;

  case 3:
#line 99 "mathparse.y"
    { eprintf("2: parse error\n"); yyerrok; YYACCEPT; ;}
    break;

  case 6:
#line 109 "mathparse.y"
    { MATH(end_of_statement)(yyvsp[-1].d.line, p, yyvsp[-1].d.exp); ;}
    break;

  case 11:
#line 114 "mathparse.y"
    { MATH(sbreak)(yyvsp[-1].d.line, p); ;}
    break;

  case 12:
#line 115 "mathparse.y"
    { MATH(scontinue)(yyvsp[-1].d.line, p); ;}
    break;

  case 13:
#line 116 "mathparse.y"
    {
								ERR("%d: Parse error\n", yyvsp[-1].d.line);
								yyerrok;
								yyval.d.exp = NULL; 
							;}
    break;

  case 14:
#line 121 "mathparse.y"
    {
								ERR("%d: Parse error. Missing semicolon?\n", yyvsp[-1].d.line);
								yyerrok;
								yyval.d.exp = NULL; 
							;}
    break;

  case 16:
#line 130 "mathparse.y"
    { MATH(nop)(yyvsp[-1].d.line, p); ;}
    break;

  case 19:
#line 137 "mathparse.y"
    { MATH(stmt_if)(yyvsp[-3].d.line, &p, yyvsp[-1].d.exp); ;}
    break;

  case 20:
#line 138 "mathparse.y"
    { yyval.d.exp = MATH(stmt_if_end)(0, &p); ;}
    break;

  case 22:
#line 143 "mathparse.y"
    { MATH(stmt_if_else)(0, &p); ;}
    break;

  case 24:
#line 148 "mathparse.y"
    { MATH(stmt_loop_start)(yyvsp[-3].d.line, &p); ;}
    break;

  case 25:
#line 149 "mathparse.y"
    { yyval.d.exp = MATH(stmt_while_end)(0, &p, yyvsp[-3].d.exp); ;}
    break;

  case 26:
#line 154 "mathparse.y"
    { MATH(stmt_loop_start)(yyvsp[0].d.line, &p); ;}
    break;

  case 27:
#line 155 "mathparse.y"
    { yyval.d.exp = MATH(stmt_do_end)(0, &p, yyvsp[-1].d.exp); ;}
    break;

  case 28:
#line 163 "mathparse.y"
    { MATH(stmt_loop_start)(yyvsp[-7].d.line, &p); ;}
    break;

  case 29:
#line 164 "mathparse.y"
    { yyval.d.exp = MATH(stmt_for_end)(0, &p, yyvsp[-7].d.exp, yyvsp[-5].d.exp, yyvsp[-3].d.exp); ;}
    break;

  case 31:
#line 173 "mathparse.y"
    { yyval.d.exp = NULL; ;}
    break;

  case 33:
#line 178 "mathparse.y"
    { yyval.d.exp = MATH(number)(yyvsp[0].d.line, yyvsp[0].d.num); ;}
    break;

  case 34:
#line 179 "mathparse.y"
    { yyval.d.exp = MATH(variable)(yyvsp[0].d.line, yyvsp[0].d.str); ;}
    break;

  case 35:
#line 180 "mathparse.y"
    { yyval.d.exp = yyvsp[0].d.exp; ;}
    break;

  case 36:
#line 181 "mathparse.y"
    { yyval.d.exp = yyvsp[0].d.exp; ;}
    break;

  case 37:
#line 182 "mathparse.y"
    { yyval.d.exp = MATH(var_assgn)(yyvsp[-1].d.line, p, yyvsp[-2].d.str, yyvsp[0].d.exp); ;}
    break;

  case 38:
#line 183 "mathparse.y"
    { yyval.d.exp = MATH(var_assgn_plus)(yyvsp[-1].d.line, p, yyvsp[-2].d.str, yyvsp[0].d.exp); ;}
    break;

  case 39:
#line 184 "mathparse.y"
    { yyval.d.exp = MATH(var_assgn_min)(yyvsp[-1].d.line, p, yyvsp[-2].d.str, yyvsp[0].d.exp); ;}
    break;

  case 40:
#line 185 "mathparse.y"
    { yyval.d.exp = MATH(var_assgn_div)(yyvsp[-1].d.line, p, yyvsp[-2].d.str, yyvsp[0].d.exp); ;}
    break;

  case 41:
#line 186 "mathparse.y"
    { yyval.d.exp = MATH(var_assgn_mul)(yyvsp[-1].d.line, p, yyvsp[-2].d.str, yyvsp[0].d.exp); ;}
    break;

  case 42:
#line 188 "mathparse.y"
    { yyval.d.exp = MATH(vararray_assgn)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 43:
#line 189 "mathparse.y"
    { yyval.d.exp = MATH(vararray_assgn_plus)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 44:
#line 190 "mathparse.y"
    { yyval.d.exp = MATH(vararray_assgn_min)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 45:
#line 191 "mathparse.y"
    { yyval.d.exp = MATH(vararray_assgn_div)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 46:
#line 192 "mathparse.y"
    { yyval.d.exp = MATH(vararray_assgn_mul)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 47:
#line 194 "mathparse.y"
    { yyval.d.exp = MATH(or)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 48:
#line 195 "mathparse.y"
    { yyval.d.exp = MATH(not)(yyvsp[-1].d.line, p, yyvsp[0].d.exp); ;}
    break;

  case 49:
#line 196 "mathparse.y"
    { yyval.d.exp = MATH(lnot)(yyvsp[-1].d.line, p, yyvsp[0].d.exp); ;}
    break;

  case 50:
#line 197 "mathparse.y"
    { yyval.d.exp = MATH(and)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 51:
#line 198 "mathparse.y"
    { yyval.d.exp = MATH(xor)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 52:
#line 199 "mathparse.y"
    { yyval.d.exp = MATH(mod )(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 53:
#line 201 "mathparse.y"
    { yyval.d.exp = MATH(oror)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 54:
#line 202 "mathparse.y"
    { yyval.d.exp = MATH(andand)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 55:
#line 204 "mathparse.y"
    { yyval.d.exp = MATH(gr)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 56:
#line 205 "mathparse.y"
    { yyval.d.exp = MATH(ls)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 57:
#line 206 "mathparse.y"
    { yyval.d.exp = MATH(ge)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 58:
#line 207 "mathparse.y"
    { yyval.d.exp = MATH(le)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 59:
#line 208 "mathparse.y"
    { yyval.d.exp = MATH(eq)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 60:
#line 209 "mathparse.y"
    { yyval.d.exp = MATH(neq)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 61:
#line 211 "mathparse.y"
    { yyval.d.exp = MATH(plus)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 62:
#line 212 "mathparse.y"
    { yyval.d.exp = MATH(minus)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 63:
#line 213 "mathparse.y"
    { yyval.d.exp = MATH(negate)(yyvsp[-1].d.line, p, yyvsp[0].d.exp); ;}
    break;

  case 64:
#line 214 "mathparse.y"
    { yyval.d.exp = MATH(divide)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 65:
#line 215 "mathparse.y"
    { yyval.d.exp = MATH(multiply)(yyvsp[-1].d.line, p, yyvsp[-2].d.exp, yyvsp[0].d.exp); ;}
    break;

  case 66:
#line 216 "mathparse.y"
    { yyval.d.exp = yyvsp[-1].d.exp; ;}
    break;

  case 67:
#line 217 "mathparse.y"
    { yyval.d.exp = NULL; ;}
    break;

  case 68:
#line 223 "mathparse.y"
    { MATH(funct_start)(yyvsp[-1].d.line, &p); ;}
    break;

  case 69:
#line 224 "mathparse.y"
    { yyval.d.exp = MATH(funct)(0, &p, yyvsp[-4].d.str); ;}
    break;

  case 74:
#line 238 "mathparse.y"
    { MATH(end_of_statement)(yyvsp[0].d.line, p, yyvsp[0].d.exp); ;}
    break;

  case 75:
#line 243 "mathparse.y"
    { MATH(array_start)(yyvsp[0].d.line, &p); ;}
    break;

  case 76:
#line 244 "mathparse.y"
    { yyval.d.exp = MATH(array)(0, &p, yyvsp[-2].d.str); ;}
    break;

  case 79:
#line 253 "mathparse.y"
    { MATH(end_of_statement)(yyvsp[-1].d.line, p, yyvsp[-1].d.exp); ;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1658 "mathparse.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 257 "mathparse.y"


