/* scivi - visualization plugin for XMMS
 * Copyright (C) 2003 Vitaly V. Bursov <vitalyb@mail333.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef UTILX_H
#define UTILX_H

#include "scivi.h"
#include "dynam.h"

int scivi_init_x(Scivi *scivi);
int scivi_query_pointer(Scivi *scivi, DynamicsData *d);
void scivi_finit_x(Scivi *scivi, int code);

extern void (*scivi_activate_pbuffer)(Scivi *scivi);
extern void (*scivi_activate_window)(Scivi *scivi);
extern void (*scivi_activate_swapbuffers)(Scivi *scivi);

extern void (*scivi_switchto_window)(Scivi *scivi);
extern void (*scivi_switchto_root)(Scivi *scivi);
extern void (*scivi_switchto_fullscreen)(Scivi *scivi);


#endif /* UTILX_H */
